---
title: XRReferenceSpace.getOffsetReferenceSpace()
slug: Web/API/XRReferenceSpace/getOffsetReferenceSpace
tags:
  - API
  - AR
  - Mixed
  - Orientation
  - Position
  - Reality
  - Reference
  - Rotate
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRReferenceSpace
  - augmented
  - getOffsetReferenceSpace
  - move
  - movement
---
<p>{{APIRef("WebXR Device API")}}{{secureContext_header}}</p>

<p><span class="seoSummary">The {{domxref("XRReferenceSpace")}} interface's <code><strong>getOffsetReferenceSpace()</strong></code> method returns a new reference space object which describes the relative difference in position between the object on which the method is called and a given point in 3D space.</span> The object returned by <code>getOffsetReferenceSpace()</code> is an {{domxref("XRReferenceSpace")}} if called on an <code>XRReferenceSpace</code>, or an {{domxref("XRBoundedReferenceSpace")}} if called on an object of that type.</p>

<p>In other words, when you have an object in 3D space and need to position another object relative to that one, you can call <code>getOffsetReferenceSpace()</code>, passing into it the position and orientation you want the second object to have <em>relative to the position and orientation of the object on which you call <code>getOffsetReferenceSpace()</code></em>.</p>

<p>Then, when drawing the scene, you can use the offset reference space to not only position objects relative to one another, but to apply the needed transforms to render objects properly based upon the viewer's position. This is demonstrated in the example {{anch("Implementing rotation based on non-XR inputs")}}, which demonstrates a way to use this method to let the user use their mouse to pitch and yaw their viewing angle.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>offsetReferenceSpace</em> = <em>xrReferenceSpace</em>.getOffsetReferenceSpace(<em>originOffset</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>originOffset</code></dt>
 <dd>An {{domxref("XRRigidTransform")}} specifying the offset to the origin of the new reference space. These values are added to the position and orientation of the current reference space and then the result is used as the position and orientation of the newly created {{domxref("XRReferenceSpace")}}.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref("XRReferenceSpace")}} object describing a reference space with the same native origin as the reference space on which the method was called, but with an origin offset indicating the distance from the object to the point given by <code>originOffset</code>.</p>

<p>If the object on which you call this method is an {{domxref("XRBoundedReferenceSpace")}}, the returned object is one as well. The {{domxref("XRBoundedReferenceSpace.boundsGeometry", "boundsGeometry")}} of the new reference space is set to the original object's <code>boundsGeometry</code> with each of its points multiplied by the inverse of <code>originOffset</code>.</p>

<h2 id="Examples">Examples</h2>

<p>Below are some examples showing how to use <code>getOffsetReferenceSpace()</code>.</p>

<h3 id="Teleporting_or_setting_the_position_of_the_viewer">Teleporting or setting the position of the viewer</h3>

<p>Upon first creating a scene, you may need to set the user's position within the 3D world. You can do that using <code>getOffsetReferenceSpace()</code>.</p>

<pre class="brush: js notranslate">xrSession.requestReferenceSpace("local")
.then((refSpace) =&gt; {
  xrReferenceSpace = refSpace;
  xrReferenceSpace = xrReferenceSpace.getOffsetReferenceSpace(
        new XRRigidTransform(startPosition, {x:0, y:0, z:1.0, w: 1.0}));
  xrSession.requestAnimationFrame(drawFrame);
});</pre>

<p>In this code, we obtain a local reference space, then use <code>getOffsetReferenceSpace()</code> to create a new space whose origin is adjusted to a position given by <code>startPosition</code> and whose orientation is looking directly along the Z axis. Then the first animation frame is requested using {{domxref("XRSession")}}'s {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}}.</p>

<h3 id="Implementing_rotation_based_on_non-XR_inputs">Implementing rotation based on non-XR inputs</h3>

<p>The input controls supported directly by WebXR are all dedicated VR or AR input devices. In order to use mouse, keyboard, or other input devices to move or otherwise transform objects in the 3D space—or to allow the user to move through the space—you'll need to write some code to read the inputs and move perform the movements.</p>

<p>This is another good use case for <code>getOffsetReferenceSpace()</code>. In this example, we'll show code that lets the user look around by right-clicking and moving the mouse to change the viewing angle.</p>

<p>First, we add an event handler for {{domxref("Element.mousemove_event", "mousemove")}} events, which calls our code to perform the rotation if the right mouse button is down. Note also that we set {{domxref("Element.oncontextmenu", "oncontextmenu")}} up to be ignored by calling {{domxref("Event.preventDefault", "preventDefault()")}} on those events. This prevents the right-clicks from causing the context menu from appearing in the browser.</p>

<pre class="brush: js notranslate">canvas.oncontextmenu = (event) =&gt; { event.preventDefault(); };
canvas.addEventListener("mousemove", (event) =&gt; {
  if (event.buttons &amp; 2) {
    rotateViewBy(event.movementX, event.movementY);
  }
});
</pre>

<p>Next, the <code>rotateViewBy()</code> function, which updates the mouse look direction's yaw and pitch based on the mouse delta values from the <code>mousemove</code> event. The pitch is restricted so that you can't look beyond straight up and straight down. Each time this is called, the new offsets are used to update the current values of <code>mousePitch</code> and <code>mouseYaw</code>.</p>

<pre class="brush: js notranslate">let mouseYaw = 0.0;
let mousePitch = 0.0;
const inverseOrientation = quat.create();
const MOUSE_SPEED = 0.003;

function rotateViewBy(dx, dy) {
  mouseYaw += dx * MOUSE_SPEED;
  mousePitch += dy * MOUSE_SPEED;

  if (mousePitch &lt; -Math.PI * 0.5) {
    mousePitch = -Math.PI * 0.5;
  } else if (mousePitch &gt; Math.PI * 0.5) {
    mousePitch = Math.PI * 0.5;
  }
}</pre>

<p>Finally, we need code that actually applies the computed yaw and pitch to the viewer's orientation. This function, <code>applyMouseMovement()</code>, handles that:</p>

<pre class="brush: js notranslate">function applyMouseMovement(refSpace) {
  if (!mouseYaw &amp;&amp; !mousePitch) {
    return refSpace;
  }

  quat.identity(inverseOrientation);
  quat.rotateX(inverseOrientation, inverseOrientation, -mousePitch);
  quat.rotateY(inverseOrientation, inverseOrientation, -mouseYaw);

  let newTransform = new XRRigidTransform({x: 0, y:  0, z: 0},
                         {x: inverseOrientation[0], y: inverseOrientation[1],
                          z: inverseOrientation[2], w: inverseOrientation[3]});

  return refSpace.getOffsetReferenceSpace(newTransform);
}</pre>

<p>This function creates an inverse orientation matrix—used to orient the viewer—from the current pitch and yaw values, then uses that matrix as the source of the orientation when calling {{domxref("XRRigidTransform.XRRigidTransform", "new XRRigidTransform()")}}. The new {{domxref("XRRigidTransform")}}'s reference space is then fetched and returned to the caller.</p>

<p>This new reference space is one in which the viewer's position is unchanged, but their orientation has been altered based on the pitch and yaw values generated from the accumulated mouse inputs. <code>applyMouseMovement()</code> should be called when drawing a frame, immediately before fetching the viewer's pose using {{domxref("XRFrame.getViewerPose", "getViewerPose()")}}, and the rendering should be performed in this reference space.</p>

<p>You can see code similar to this in use in our broader WebXR tutorial article called <a href="/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion">Movement, orientation, and motion</a>. In particular, check out the section called <a href="/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion#Starting_up_the_WebXR_session">Starting up the WebXR session</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrreferencespace-getoffsetreferencespace','getOffsetReferenceSpace()')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.XRReferenceSpace.getOffsetReferenceSpace")}}</p>
